
local BList = {};

BulletEffects = {};

function BulletEffects.createEffect(position)
    local sprite = lj2d.graphics.createSprite(BulletEffects._tex);
    sprite:setPivot(luajogo.vec2(0.5, 0.5));
    sprite:setPosition(position);
    sprite:setSize(luajogo.vec2(30, 30));
    local fx = SpriteAnimation.create(sprite, BulletEffects._anim);
    fx:play();

    table.insert(BList, fx);
end

function BulletEffects.load()
    BulletEffects._tex = luajogo.texture.load(luajogo.assets.load("/bullet_impact.png"));

    BulletEffects._anim = {
        { time = 0.075, region = { position = luajogo.vec2(59 * 0, 44), size = luajogo.vec2(59, 59) } },
        { time = 0.075, region = { position = luajogo.vec2(59 * 1, 44), size = luajogo.vec2(59, 59) } },
        { time = 0.075, region = { position = luajogo.vec2(59 * 2, 44), size = luajogo.vec2(59, 59) } },
        { time = 0.075, region = { position = luajogo.vec2(59 * 3, 44), size = luajogo.vec2(59, 59) } },
        { time = 0.075, region = { position = luajogo.vec2(59 * 4, 44), size = luajogo.vec2(59, 59) } },
    };
end

function BulletEffects.update(deltaTime)
    local deadFX = {};
    for _, fx in pairs(BList) do
        if not fx:isPlaying() then
            table.insert(deadFX, fx);
        else
            fx:update(deltaTime);
        end
    end
    for _, fx in pairs(deadFX) do
        fx:destroy();
        table.removeValue(BList, fx);
    end
end

function BulletEffects.draw()
    for _, fx in pairs(BList) do
        fx:sprite():draw();
    end
end

function BulletEffects.quit()
    for _, fx in pairs(BList) do
        fx:destroy();
    end
    BList = {};
end