
local Sources = {};

Sounds = {};

function Sounds.load()
    Sounds._pistolClip = lj2d.audio.createClip(luajogo.assets.load("/pistol.wav"));
    Sounds._crackClip = lj2d.audio.createClip(luajogo.assets.load("/crack.wav"));
    Sounds._impactClip = lj2d.audio.createClip(luajogo.assets.load("/impactWood.wav"));

    Sounds._musicVolume = 0.2;
    Sounds._musicBuffVolume = 0.05;
    Sounds._musicMaxVolume = 1;
    Sounds._musicPitch = 1;
    Sounds._musicBuffPitch = -0.01;
    Sounds._musicMinPitch = 0.5;

    Sounds._musicClip = lj2d.audio.createClip(luajogo.assets.load("/miamidisco.wav"));
    Sounds._musicSrc = lj2d.audio.createSource(Sounds._musicClip);
    Sounds._musicSrc:setVolume(Sounds._musicVolume);
    Sounds._musicSrc:setPitch(Sounds._musicPitch);
    Sounds._musicSrc:setLoop(true);
    Sounds._musicSrc:play();
end

function Sounds.update(deltaTime)
    local destroySrcs = {};
    for _, src in pairs(Sources) do
        if not src:isPlaying() then
            table.insert(destroySrcs, src);
        end
    end
    for _, src in pairs(destroySrcs) do
        src:destroy();
        table.removeValue(Sources, src);
    end
end

function Sounds.buffMusic()
    Sounds._musicVolume = Sounds._musicVolume + Sounds._musicBuffVolume;
    if Sounds._musicVolume > Sounds._musicMaxVolume then
        Sounds._musicVolume = Sounds._musicMaxVolume;
    end
    Sounds._musicPitch = Sounds._musicPitch + Sounds._musicBuffPitch;
    if Sounds._musicPitch < Sounds._musicMinPitch then
        Sounds._musicPitch = Sounds._musicMinPitch;
    end
end

function Sounds.playGunshot()
    local src = lj2d.audio.createSource(Sounds._pistolClip);
    src:play();
    table.insert(Sources, src);
end

function Sounds.playBulletImpact()
    local src = lj2d.audio.createSource(Sounds._impactClip);
    src:setVolume(1);
    src:play();
    table.insert(Sources, src);
end

function Sounds.playDeath(loud)
    local src = lj2d.audio.createSource(Sounds._crackClip);
    if loud then
        src:setVolume(1);
    else
        src:setVolume(0.5);
    end
    src:play();
    table.insert(Sources, src);
end

function Sounds.quit()
    for _, src in pairs(Sources) do
        src:destroy();
    end
    Sounds._musicSrc:destroy();

    Sounds._pistolClip:destroy();
    Sounds._crackClip:destroy();
    Sounds._impactClip:destroy();
    Sounds._musicClip:destroy();

    Sources = {};
end